﻿using System.Threading.Tasks;
using UnityEngine;
using UnityEngine.SceneManagement;

public class MoreCarryWeight : Mod
{
    public async void Start()
    {
        Debug.Log("Mod MoreCarryWeight has been loaded!");
        while (InventoryBackpack.Get() == null)
        {
            await Task.Delay(1000);
        }
        if (PlayerPrefs.HasKey("mod_morecarryweight_maxweight"))
        {
            InventoryBackpack.Get().m_MaxWeight = PlayerPrefs.GetInt("mod_morecarryweight_maxweight");
        }
        else
        {
            InventoryBackpack.Get().m_MaxWeight = 300f;
            PlayerPrefs.SetInt("mod_morecarryweight_maxweight", 300);
        }
    }

    [ConsoleCommand("setcarryweight", "Allows you to define a custom carry weight. Syntax : setcarryweight <maxKg>")]
    public static void SetCarryweight(string[] args)
    {
        if (InventoryBackpack.Get() == null)
        {
            Debug.LogWarning("You can't set the carry weight right now. Please load in a game to use this command.");
            return;
        }
        if (args.Length >= 1)
        {
            try
            {
                int kg = int.Parse(args[0]);
                InventoryBackpack.Get().m_MaxWeight = kg;
                PlayerPrefs.SetInt("mod_morecarryweight_maxweight", kg);
                Debug.Log("Max Carry Weight set to " + kg + "kg");
            }
            catch
            {
                Debug.LogWarning("Wrong syntax! Syntax : setcarryweight <maxKg>");
                return;
            }
        }
        else
        {
            Debug.Log("Currently Saved Max Carry Weight = " + PlayerPrefs.GetInt("mod_morecarryweight_maxweight") + "kg");
            return;
        }
    }

    public void OnModUnload()
    {
        if (InventoryBackpack.Get())
            InventoryBackpack.Get().m_MaxWeight = 50f;
        Debug.Log("Mod MoreCarryWeight has been unloaded!");
    }
}